#define BLYNK_PRINT Serial

#include <WiFi.h>
#include <WiFiClient.h>
#include <BlynkSimpleEsp32.h>

char auth[] = "YourAuthToken";
char ssid[] = "YourNetworkName";
char pass[] = "YourPassword";

const int humiditySensorPin = 34; 
const int relayPin = 16;           
const int humidityThreshold = 2000;

const unsigned long readInterval = 5 * 60 * 1000; // 5 minuti
const unsigned long relayOnDuration = 12 * 1000; // 12 secondi

unsigned long previousMillis = 0;
unsigned long relayActivatedMillis = 0;

bool relayOn = false;

void setup() {

  Serial.begin(9600);
  pinMode(relayPin, OUTPUT);
  digitalWrite(relayPin, LOW);

  Blynk.begin(auth, ssid, pass);
}

void loop() {

  Blynk.run();

  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis >= readInterval) {
    previousMillis = currentMillis;

    int humidityValue = analogRead(humiditySensorPin);
    Serial.print("Valore umidità: ");
    Serial.println(humidityValue);

    Blynk.virtualWrite(V0, humidityValue);

    if (humidityValue > humidityThreshold) {
      digitalWrite(relayPin, HIGH);
      relayOn = true;
      relayActivatedMillis = currentMillis;
      Serial.println("Relè acceso per 30 secondi");
    }
  }

  if (relayOn && currentMillis - relayActivatedMillis >= relayOnDuration) {
    digitalWrite(relayPin, LOW);
    relayOn = false;
    Serial.println("Relè spento");
  }
}
